#ifndef _qmetaobject_h_
#define _qmetaobject_h_

#include <qdefs.h>

class QObject;

typedef void (QObject::*QMember)();

// I'm assuming QMetaData goes here 'cuz the moc file doesn't include anything
// else.
class QMetaData
{
public:
	// name is a pointer because a constant string is assigned to it
	char *name;
	// i assume the type of 'QMember' because of the cast in the moc file 
	QMember ptr;
};

class QMetaObject 
{
//private:
public:
	// this fixed array should be dynamic!?
	QMetaData *slotTable;
	QMetaData *signalTable;
	int numSignals;
	int numSlots;
	char className[MAXCLASSNAME];
	char parent[MAXCLASSNAME];
public:
	QMetaObject::QMetaObject (char *className, char *dunno, 
				QMetaData *slotTable, int numSlotItems, 
				QMetaData *signalTable, int numSignalItems);
	QMember get_slot_ptr(char *slotName);
	QMember get_signal_ptr(char *sigName);
};

#endif
