#ifndef _qobject_h_
#define _qobject_h_

#include <qmetaobject.h>

// This information was obtained by looking at the output of the moc
// precompiler, and various programs that use qt. 
//
// moc bitches if metaObj is not static...
// which means i had to make it private...i think this is right
//
// actually you only would want this one time per class so this makes sense 
// now.
#define Q_OBJECT \
private:						\
	static QMetaObject *metaObj;			\
public:							\
	const char *className() const; 			\
	virtual QMetaObject *metaObject() { return this->metaObj; }	\
	virtual void initMetaObject();
		 
#define slots 
#define signals	public
#define SLOT(x) #x
#define SIGNAL(x) #x
#define emit

// nice macro from comp.lang.c++ faq
#define callMemberFunction(object,ptrToMember)  ((object).*(ptrToMember))

const int MAXCALLBACK = 100;

typedef void (QObject::*QMember)();
 
class QObject
{
Q_OBJECT 

private:
	// this stuff should be its own class and a linked list
	char *callbackSignalName[MAXCALLBACK];
	QObject *callbackObject[MAXCALLBACK];
	QMember callbackFunc[MAXCALLBACK];
	int numCallbacks;
public:							
	QObject();
	~QObject();
	void badSuperclassWarning(char *obj, char *classname) {}
	void activate_signal( char *sigName, int t0 );
	void activate_signal( char *sigName );
	void add_callback( char *sigName, QObject *receiver, QMember func);
	static connect(QObject *sender, char *sigName, QObject *receiver, char *slotName );
};
#endif
